#!/usr/local/bin/ruby
$KCODE='e'
print "Content-type:text/html\n\n"

require 'erb'
require 'mysql'
require 'cgi'
params = CGI.new.params

#----MySQL³----
ACCOUNT = 'xxxxxx'
PASSWORD = '******'
#---------------------

sql = <<EOS
SELECT
	TBL_SECTIONID.sectionid_name AS sectionid_name,
	TBL_DIFFICULTY.difficulty_name AS difficulty_name,
	TBL_AREA.area_name_ja AS area_name_ja,
	IF(TBL_RARE.difficulty_id = 3, TBL_ENEMY.enemy_name_ult_ja, TBL_ENEMY.enemy_name_ja) AS enemy_name_ja,
	TBL_ICON.icon_filename AS icon_filename,
	TBL_ITEM.item_name_ja AS item_name_ja,
  TBL_ENEMY_DROP.enemy_drop_percentage AS enemy_drop_percentage,
  TBL_RARE.rare_rate AS rare_rate,
	TBL_RARE.rare_percentage AS rare_percentage,
  TBL_ENEMY.enemy_rare AS enemy_rare,
  1 - (TBL_ENEMY_DROP.enemy_drop_percentage/100) * (TBL_RARE.rare_percentage/100) AS real_rate
FROM
	TBL_RARE
	INNER JOIN TBL_SECTIONID ON TBL_RARE.sectionid_id=TBL_SECTIONID.sectionid_id
	INNER JOIN TBL_DIFFICULTY ON TBL_RARE.difficulty_id=TBL_DIFFICULTY.difficulty_id
	INNER JOIN TBL_AREA ON TBL_RARE.area_id=TBL_AREA.area_id
	INNER JOIN TBL_ENEMY ON TBL_RARE.enemy_id=TBL_ENEMY.enemy_id
	INNER JOIN TBL_ITEM ON TBL_RARE.item_type_id=TBL_ITEM.item_type_id AND TBL_RARE.item_id=TBL_ITEM.item_id
  INNER JOIN TBL_ICON ON TBL_ITEM.icon_id=TBL_ICON.icon_id
  INNER JOIN TBL_ENEMY_DROP ON TBL_RARE.difficulty_id=TBL_ENEMY_DROP.difficulty_id AND TBL_RARE.enemy_id=TBL_ENEMY_DROP.enemy_id
WHERE 1
EOS

def get_expected_killcount(drop, rate, expectation)
  return 0 if drop == 0.0 || rate == 0.0 || expectation == 1.0
  return 1 if drop * rate == 1
  (Math.log(1 - expectation) / Math.log(1 - drop * rate)).ceil
end

def get_cond(param, fld)
  s = ""
  if param.length > 0
    s += " And ("
    param.each_with_index do |i, idx|
      s += " Or" if idx > 0
      s += " #{fld}=#{i}"
    end
    s += ")"
  end
  s
end
begin
sql += get_cond(params['sid'], 'TBL_RARE.sectionid_id')
sql += get_cond(params['diff'], 'TBL_RARE.difficulty_id')
sql += get_cond(params['ep'], 'TBL_AREA.episode_id')
sql += get_cond(params['area'], 'TBL_ENEMY.area_id')
sql += get_cond(params['en'], 'TBL_RARE.enemy_id')
sql += get_cond(params['itype'], 'TBL_RARE.item_type_id')
if params['item'].length > 0
  sql += " And ("
  params['item'].each_with_index do |i, idx|
    sql += " Or" if idx > 0
    sql += " (TBL_RARE.item_type_id=#{i.to_i / 1000} And TBL_RARE.item_id=#{i.to_i % 1000})"
  end
  sql += ")"
end

if params['cls'].length > 0
  sql += " And ("
  params['cls'].each_with_index do |i, idx|
    sql += " Or" if idx > 0
    sql += " (" +
    case i.to_i
      when 0, 3, 6, 10, 11
        "TBL_ITEM.item_flag_human"
      when 1, 7, 8
        "TBL_ITEM.item_flag_newman"
      when 2, 4, 5, 9
        "TBL_ITEM.item_flag_android"
    end
    sql += "=1 And "
    
    sql +=
    case i.to_i
      when 0, 1, 2, 9
        "TBL_ITEM.item_flag_hunter"
      when 3, 4, 5, 11
        "TBL_ITEM.item_flag_ranger"
      when 6, 7, 8, 10
        "TBL_ITEM.item_flag_force"
    end
    sql += "=1 And "
    
    sql +=
    case i.to_i
      when 0, 2, 3, 4, 7, 10
        "TBL_ITEM.item_flag_male"
      when 1, 5, 6, 8, 9, 11
        "TBL_ITEM.item_flag_female"
    end
    sql += "=1)"
  end
  sql += ")"
end

if params['race'].length > 0
  sql += " And ("
  params['race'].each_with_index do |i, idx|
    sql += " Or" if idx > 0
    sql += " "
    
    sql +=
    case i.to_i
      when 0
        "TBL_ITEM.item_flag_human"
      when 1
        "TBL_ITEM.item_flag_newman"
      when 2
        "TBL_ITEM.item_flag_android"
    end
    sql += "=1"
  end
  sql += ")"
end

if params['ctype'].length > 0
  sql += " And ("
  params['ctype'].each_with_index do |i, idx|
    sql += " Or" if idx > 0
    sql += " "
    
    sql +=
    case i.to_i
      when 0
        "TBL_ITEM.item_flag_hunter"
      when 1
        "TBL_ITEM.item_flag_ranger"
      when 2
        "TBL_ITEM.item_flag_force"
    end
    sql += "=1"
  end
  sql += ")"
end

if params['sex'].length > 0
  sql += " And ("
  params['sex'].each_with_index do |i, idx|
    sql += " Or" if idx > 0
    sql += " "
    
    sql +=
    case i.to_i
      when 0
        "TBL_ITEM.item_flag_male"
      when 1
        "TBL_ITEM.item_flag_female"
    end
    sql += "=1"
  end
  sql += ")"
end


rescue
puts $!
end

FIELD = [ ['sid', 'TBL_RARE.sectionid_id'],
          ['diff', 'TBL_RARE.difficulty_id'],
          ['ep', 'TBL_AREA.episode_id'],
          ['area', 'TBL_RARE.area_id'],
          ['en', 'TBL_RARE.enemy_id'],
          ['itype', 'TBL_RARE.item_type_id'],
          ['item', 'TBL_ITEM.item_name_ja'],
          ['drop', 'TBL_ENEMY_DROP.enemy_drop_percentage'],
          ['rate', 'TBL_RARE.rare_rate'],
          ['exp', 'real_rate'] ]
HASH_FIELD = Hash[*FIELD.flatten]

sql += "\nORDER BY"
if params['sort'].length > 0
  params['sort'].each do |i|
    next unless HASH_FIELD[i]
    sql += ",\n\t" + HASH_FIELD[i]
    sql += " DESC" if params['desc'].to_s == 'on'
  end
end
FIELD.each do |f|
  sql += ",\n\t" + f[1] unless params['sort'].include?(f[0])
end
sql.gsub!('ORDER BY,', 'ORDER BY')

sql += "\n;"

begin
CONN = Mysql.new(nil, ACCOUNT, PASSWORD, ACCOUNT)
res_qry = CONN.query(sql)
rescue
  puts $!
end
#puts "<pre>#{sql}</pre>"

begin
  TMPL = 'droplist-result.rhtml'
  
  File.open(TMPL, 'r') do |file|
    ERB.new(file.read).run
  end
rescue
  puts "顼Ǥ衣"
  puts $!
  
  puts "<pre>#{sql}<pre>"
ensure
  CONN.close
end
