var LANG = "ja";
var FOOD_MAX = 100;
var UNDO_MAX = 100;
var undoBuffer = new Array();
var historyBuffer = new Array();
var isRecordingRotation = false;
var rotationBuffer = new Array();

var mag = new Mag();

function init() {
	document.getElementById("max_number_of_food").innerHTML = FOOD_MAX.toString();
	updateStatus();
	updateMagInfo();
	updateGrowth(MAG_DATA[mag.mag][FEATURE_GROWTH]);
	updateMagDescription();
}

function feed(food, count, lv_lim /* = 0 */) {
	keepUndo();
	if(lv_lim == undefined) lv_lim = 0;
	if(isRecordingRotation) rotationBuffer.push([food, count]);
	var temp_hist = new Array();
	var klass = parseInt(getSelectValue("ch", "klass"));
	var sectionid = parseInt(getSelectValue("ch", "id"));
	var rounddown = document.rounddown.rdownchk.checked;
	for(var i = 0; i < count; i++) {
		if(lv_lim > 0 && mag.level() >= lv_lim) break;
		mag.feed(food, klass, sectionid, rounddown);
		if(mag.evolved) {
			updateMagInfo();
			updateGrowth(MAG_DATA[mag.mag][FEATURE_GROWTH]);
			updateMagDescription();
		}
		temp_hist.push([food, klass, sectionid, rounddown, mag.mag]);
	}
	if(temp_hist.length > 0) historyBuffer.push(temp_hist);
	updateStatus();
}

function updateStatus() {
	document.getElementById("magname").innerHTML = mag.getName(LANG);
	document.getElementById("magpb").innerHTML = mag.getPB(LANG).join("<br />");
	document.getElementById("lv_total").innerHTML = mag.level();
	document.getElementById("lv_def").innerHTML = mag.lv[MAG_DEF];
	document.getElementById("ex_def").innerHTML = mag.exp[MAG_DEF];
	document.bar_def.width = mag.exp[MAG_DEF] >> 1 << 1;
	document.getElementById("lv_pow").innerHTML = mag.lv[MAG_POW];
	document.getElementById("ex_pow").innerHTML = mag.exp[MAG_POW];
	document.bar_pow.width = mag.exp[MAG_POW] >> 1 << 1;
	document.getElementById("lv_dex").innerHTML = mag.lv[MAG_DEX];
	document.getElementById("ex_dex").innerHTML = mag.exp[MAG_DEX];
	document.bar_dex.width = mag.exp[MAG_DEX] >> 1 << 1;
	document.getElementById("lv_mind").innerHTML = mag.lv[MAG_MIND];
	document.getElementById("ex_mind").innerHTML = mag.exp[MAG_MIND];
	document.bar_mind.width = mag.exp[MAG_MIND] >> 1 << 1;
	if(document.historyform.history_auto.checked)
		document.historyform.txt_history.value = historyToString();
}
function updateMagInfo() {
	var mag_info = MAG_DATA[mag.mag];
	document.getElementById("onpbmax").innerHTML = ACTION_NAME[mag_info[FEATURE_PBMAX]][langToNum(LANG)];
	document.getElementById("ondanger").innerHTML = ACTION_NAME[mag_info[FEATURE_DYING]][langToNum(LANG)];
	document.getElementById("onboss").innerHTML = ACTION_NAME[mag_info[FEATURE_BOSS]][langToNum(LANG)];
	document.getElementById("ondead").innerHTML = ACTION_NAME[mag_info[FEATURE_DEAD]][langToNum(LANG)];
	document.getElementById("pbget").innerHTML = PB_NAME[mag_info[FEATURE_PB]][langToNum(LANG)];
}

function updateGrowth(growth_pattern) {
	var formname = ["monomate", "dimate", "trimate",
	                "monofluid", "difluid", "trifluid",
	                "antidote", "antiparalyze",
	                "solatomizer", "moonatomizer", "staratomizer"];
	var params = ["def", "pow", "dex", "mind", "synchro", "iq"];
	for(var i = 0; i < formname.length; i++) {
		for(var j = 0; j < params.length; j++) {
			document.getElementById(formname[i] + "_" + params[j]).innerHTML =
				format(GROWTH_PATTERN[growth_pattern][i][j]);
		}
	}
	function format(val) {
		if(val > 0) return "+" + val.toString();
		if(val == 0) return "-";
		if(val < 0) return val.toString();
	}
}

function updateMagDescription() {
	var klass = parseInt(getSelectValue("ch", "klass"));
	var sectionid = parseInt(getSelectValue("ch", "id"));
	document.getElementById("magdescription").innerHTML = getMagDescription(mag, klass, sectionid, LANG);
}

function resetStatus() {
	keepUndo();
	clearHistory();
	mag = new Mag();
	init();
}

function saveMag() {
	var param = getRadioValue("saveslot", "slot");
	var val = mag.toCookie();
	Cookie.set(param, val);
}
function loadMag() {
	var param = getRadioValue("saveslot", "slot");
	var ck = Cookie[param];
	if(ck == undefined || ck == "") return;
	keepUndo();
	clearHistory();
	mag.loadCookie(ck);
	init();
}

function popupSaveData(e, key) {
	var ck = Cookie[key];
	if(ck == undefined || ck == "") return;
	
	var temp_mag = new Mag();
	temp_mag.loadCookie(ck);
	var msg = temp_mag.getName(LANG) + "<br />Lv " + temp_mag.level().toString();
	showPopup(e, msg, 10, -60);
}

function keepUndo() {
	undoBuffer.unshift(mag.toCookie());
	if(undoBuffer.length >= UNDO_MAX) undoBuffer.pop();
}
function undoFeeding() {
	if(undoBuffer.length == 0) return;
	mag.loadCookie(undoBuffer.shift());
	if(isRecordingRotation) rotationBuffer.pop();
	undoHistory();
	init();
}

function keepHistory(food, count) {
	historyBuffer.push([food, count]);
}
function undoHistory() {
	if(historyBuffer.length == 0) return;
	historyBuffer.pop();
}
function clearHistory() {
	historyBuffer = new Array();
}
function historyToString() {
	var prev_food = -1;
	var prev_feeder = -1;
	var prev_sectionid = -1;
	var prev_rounddown = false;
	var prev_magtype = MAG;
	
	var buff = 0;
	
	var PERIOD_FEEDING = 200;
	var buff_period = 0;
	var req_second = 0;
	var req_money = 0;
	
	var s = "";
	for(var i = 0; i < historyBuffer.length; i++) {
		for(var j = 0; j < historyBuffer[i].length; j++) {
			var food = historyBuffer[i][j][0];
			var feeder = historyBuffer[i][j][1];
			var sectionid = historyBuffer[i][j][2];
			var rounddown = historyBuffer[i][j][3];
			var magtype = historyBuffer[i][j][4];
			
			buff_period++;
			if(buff_period == 1 || rounddown) req_second += PERIOD_FEEDING;
			if(buff_period >= 3 || rounddown) buff_period = 0;
			req_money += FOOD_PRICE[food];
			
			if(food == prev_food && feeder == prev_feeder && sectionid == prev_sectionid &&
			   rounddown == prev_rounddown || (i == 0 && j == 0)) {
				buff++;
			} else {
				if(buff > 0) s += FOOD_NAME[prev_food][langToNum(LANG)] + " ~ " + buff.toString() + "\n";
				buff = 1;
			}
			if(feeder != prev_feeder || sectionid != prev_sectionid || rounddown != prev_rounddown) {
				s += "LN^[F" + CLASS_NAME[feeder] + " / " + SECTIONID_NAME[sectionid];
				s += " qɁF" + (rounddown ? "On" : "Off") + "\n";
			}
			if(magtype != prev_magtype) {
				s += FOOD_NAME[prev_food][langToNum(LANG)] + " ~ " + buff.toString() + "\n";
				buff = 0;
				s += "<" + MAG_DATA[magtype][6] + " ɐi>\n"
			}
			prev_food = food;
			prev_feeder = feeder;
			prev_sectionid = sectionid;
			prev_rounddown = rounddown;
			prev_magtype = magtype;
		}
	}
	if(buff > 0) s += FOOD_NAME[prev_food][langToNum(LANG)] + " ~ " + buff.toString() + "\n";
	var header = ""
	header += "vԁF";
	if(req_second > 0) req_second -= PERIOD_FEEDING;
	if(req_second >= 3600) header += (Math.floor(req_second / 3600)).toString() + "";
	header += (Math.floor(req_second / 60) % 60).toString() + "";
	header += (req_second % 60).toString() + "b";
	header += "@zF" + req_money.toString() + "Z^\n";
	return header + s;
}

function loadHistory() {
	var h = document.historyform.txt_history.value;
	
	var pattern = "("
	for(var i = 0; i < FOOD_NAME.length; i++) pattern += FOOD_NAME[i][0] + "|";
	pattern = pattern.slice(0, -1);
	pattern += ")\\s*~\\s*(\\d+)";
	pattern += "|(" + CLASS_NAME.join("|") + ")";
	pattern += "|(" + SECTIONID_NAME.join("|") + ")";
	pattern += "|(On|Off)";
	
	var reg = new RegExp(pattern, "gim");
	
	while(true){
		var arr = reg.exec(h);
		if(arr == null) break;
		
		if(arr[3] != null) {
			document.ch.klass.value = getIndex(arr[3], CLASS_NAME);
		} else if(arr[4] != null) {
			document.ch.id.value = getIndex(arr[4], SECTIONID_NAME);
		} else if(arr[5] != null) {
			if(arr[5].toUpperCase() == "ON") {
				document.rounddown.rdownchk.checked = true;
			} else if(arr[5].toUpperCase() == "OFF") {
				document.rounddown.rdownchk.checked = false;
			}
		} else if(arr[1] != null && arr[2] != null) {
			var food;
			for(var i = 0; i < FOOD_NAME.length; i++) {
				if(arr[1] == FOOD_NAME[i][0]) {
					food = i;
					break;
				}
			}
			feed(food, arr[2].toString());
		}
	}
	function getIndex(name, arr) {
		for(var i = 0; i < arr.length; i++) {
			if(arr[i].toUpperCase() == name.toUpperCase()) return i;
		}
		return null;
	}
}

function recordRotation() {
	isRecordingRotation = !isRecordingRotation;
	document.rotation.runrotation.disabled = isRecordingRotation;
	document.rotation.startbutton.value = isRecordingRotation ? "L^~" : "L^Jn";
	
	if(isRecordingRotation) {
		rotationBuffer = new Array();
	} else {
		//zœK
		for(var i = rotationBuffer.length - 1; i >= 0; i--) {
			if(i > 0 && rotationBuffer[i][0] == rotationBuffer[i - 1][0]) {
				rotationBuffer[i - 1][1] = parseInt(rotationBuffer[i - 1][1]) + parseInt(rotationBuffer[i][1]);
				rotationBuffer.splice(i,1);
			}
		}
	}
}

function confirmRotation() {
	var s = "";
	for(var i = 0; i < rotationBuffer.length; i++) {
		s += FOOD_NAME[rotationBuffer[i][0]][0];
		s += " ~ " + rotationBuffer[i][1].toString() + "\n";
	}
	window.alert(s);
}

function runRotation() {
	if(rotationBuffer.length == 0) return;
	
	var lv_lim = 0;
	if(document.rotation.level_auto.checked) lv_lim = parseInt(document.rotation.level_limit.value);
	if(isNaN(lv_lim) || lv_lim < 0 || lv_lim > LEVEL_MAX) {
		window.alert("wLv܂");
		return;
	}
	
	while(true) {
		if(lv_lim > 0 && mag.level() >= lv_lim) break;
		for(var i = 0; i < rotationBuffer.length; i++)
			feed(rotationBuffer[i][0], rotationBuffer[i][1], lv_lim);
		if(lv_lim == 0) break;
	}
}

function level_limit_clicked() {
	document.rotation.level_limit.disabled = !(document.rotation.level_auto.checked);
}
