var MATERIAL_MAX = new Array(3);
MATERIAL_MAX[HUMAN] = 250;
MATERIAL_MAX[NEWMAN] = 150;
MATERIAL_MAX[ANDROID] = 150;
var MATERIAL_MAX_HP = new Array(3);
MATERIAL_MAX_HP[HUMAN] = 125;
MATERIAL_MAX_HP[NEWMAN] = 125;
MATERIAL_MAX_HP[ANDROID] = 125;
var MATERIAL_MAX_TP = new Array(3);
MATERIAL_MAX_TP[HUMAN] = 125;
MATERIAL_MAX_TP[NEWMAN] = 125;
MATERIAL_MAX_TP[ANDROID] = 0;

var LEVEL_MIN = 1;
var LEVEL_MAX = 200;

function Character(klass, sectionid) {
	// properties
	this.klass = klass;
	this.level = 1;
	this.material = [0, 0, 0, 0, 0, 0, 0, 0];
	this.weapon_motion = 0;
	this.weapon = 0;
	this.weapon_enh = 0;
	this.weapon_hit = 0;
	this.armor = 0;
	this.armor_def = 0;
	this.armor_evd = 0;
	this.shield = 0;
	this.shield_def = 0;
	this.shield_evd = 0;
	this.unit = [0, 0, 0, 0];
	this.unit_adjust = [0, 0, 0, 0];
	this.mag = [5, 0, 0, 0];
}
function Character_debug() {
	var s = "";
	s += "baseStatus: [" + this.baseStatus.join(", ") + "]\n";
	s += "innerEquipment: [" + this.innerEquipment.join(", ") + "]\n";
	s += "innerStatus: [" + this.innerStatus.join(", ") + "]\n";
	s += "statusDiff: [" + this.statusDiff.join(", ") + "]\n";
	s += "outerEquipment: [" + this.outerEquipment.join(", ") + "]\n";
	s += "outerStatus: [" + this.outerStatus.join(", ") + "]\n";
	s += "resistanceSum: [" + this.resistanceSum.join(", ") + "]\n";
	s += "mindExcludeWand: " + this.mindExcludeWand
	alert(s);
}
Character.prototype.debug = Character_debug;

//method: recalc()
function Character_recalc() {
	//result keepers
	this.baseStatus = new Array(8);
	this.innerEquipment = new Array(8);
	this.innerStatus = new Array(8);
	this.statusDiff = new Array(8);
	this.outerEquipment = new Array(8);
	this.outerStatus = new Array(8);
	this.resistanceSum = new Array(5);
	this.mindExcludeWand = 0;
	
	this.baseStatus = STATUS[this.klass][this.level];
	
	var w = new PSOItem(this.weapon_motion, this.weapon);
	w.enh_atk = this.weapon_enh;
	w.enh_hit = this.weapon_hit;
	this.getWeapon = w;
	
	var a = new PSOItem(ITEMTYPE_ARMOR, this.armor);
	a.enh_def = this.armor_def;
	a.enh_evd = this.armor_evd;
	this.getArmor = a;
	
	var s = new PSOItem(ITEMTYPE_SHIELD, this.shield);
	s.enh_def = this.shield_def;
	s.enh_evd = this.shield_evd;
	this.getShield = s;
	
	this.getUnit = new Array(this.unit.length);
	
	for(var i = 0; i < this.unit.length; i++) {
		var u = new PSOItem(ITEMTYPE_UNIT, this.unit[i]);
		u.enh_unit = this.unit_adjust[i];
		this.getUnit[i] = u;
		
		this.innerEquipment = this.innerEquipment.merge(u.getUnitStatus());
		this.resistanceSum = this.resistanceSum.merge(u.getResistance());
	}
	this.innerEquipment = this.innerEquipment.merge(w.getInnerStatus()).merge(a.getInnerStatus()).merge(s.getInnerStatus());
	this.resistanceSum = this.resistanceSum.merge(w.getResistance()).merge(a.getResistance()).merge(s.getResistance());
	
	var temp = new Array(8);
	temp = this.baseStatus.merge(this.material).merge(this.material).merge(this.innerEquipment);
	temp = temp.merge([0, 0, this.mag[1] * 2, this.mag[0], this.mag[3] * 2, this.mag[2] * 0.5, 0, 0]);
	
	this.statusLimit = STATUS_LIMIT[this.klass];
	
	for(var i = 0; i < this.innerStatus.length; i++)
		if(this.statusLimit[i] == -1 || temp[i] <= this.statusLimit[i]) {
			this.innerStatus[i] = temp[i];
		} else {
			this.innerStatus[i] = this.statusLimit[i];
		}
	this.innerStatus[STATUS_TP] = getTP(this.innerStatus[STATUS_MIND], this.level, this.klass, this.innerStatus[STATUS_TP] - this.baseStatus[STATUS_TP]);
	
	this.mindExcludeWand = temp[STATUS_MIND] - w.getInnerStatus()[STATUS_MIND];
	if(this.mindExcludeWand > this.statusLimit[STATUS_MIND]) this.mindExcludeWand = this.statusLimit[STATUS_MIND];
	
	for(var i = 0; i < this.statusDiff.length; i++)
		this.statusDiff[i] = (this.statusLimit[i] == -1)? "-" : temp[i] - this.statusLimit[i];
	
	this.outerEquipment = w.getOuterStatus().merge(a.getOuterStatus()).merge(s.getOuterStatus());
	
	this.outerStatus = this.innerStatus.merge(this.outerEquipment);
}
Character.prototype.recalc = Character_recalc;

function Character_getMaterialSum() {
	var sum = 0;
	for(var i = 0; i < this.material.length; i++)
		if(i != STATUS_HP && i != STATUS_TP) sum += parseInt(this.material[i]);
	return sum;
}
Character.prototype.getMaterialSum = Character_getMaterialSum;

function Character_getMaterialLimit(mat /*= "all"*/) {
	if(mat == undefined) mat = "all";
	switch(mat) {
		case "all" : return MATERIAL_MAX[getRace(this.klass)];
		case "hp" : return MATERIAL_MAX_HP[getRace(this.klass)];
		case "tp" : return MATERIAL_MAX_TP[getRace(this.klass)];
	}
}
Character.prototype.getMaterialLimit = Character_getMaterialLimit;

function Character_getMagLevelSum() {
	var sum = 0;
	for(var i = 0; i < this.mag.length; i++)
		sum += parseInt(this.mag[i]);
	return sum;
}
Character.prototype.getMagLevelSum = Character_getMagLevelSum;

function Character_toCookie() {
	var st = [this.klass, this.level, this.material.join("_"),
	          this.unit.join("_"), this.unit_adjust.join("_"),
	          this.mag.join("_"),
	          this.weapon_motion, this.weapon, this.weapon_enh, this.weapon_hit,
	          this.armor, this.armor_def, this.armor_evd,
	          this.shield, this.shield_def, this.shield_evd];
	return encodeURIComponent(base64encode(st.join("_")));
}
Character.prototype.toCookie = Character_toCookie;

function Character_loadCookie(cookie) {
	var COOKIE_PARAMS = 1 + 1 + this.material.length + this.unit.length +
	                    this.unit_adjust.length + this.mag.length;
	var COOKIE_PARAMS_EQUIP = COOKIE_PARAMS + 10;
	
	var st = base64decode(decodeURIComponent(cookie)).split("_");
	if(st.length != COOKIE_PARAMS && st.length != COOKIE_PARAMS_EQUIP) {
		window.alert("f[^ȂAÂ`łB");
		return false;
	}
	var counter = 0;
	this.klass = parseInt(st[counter++]);
	this.level = parseInt(st[counter++]);
	for(var i = 0; i < this.material.length; i++)
		this.material[i] = parseInt(st[counter++]);
	for(var i = 0; i < this.unit.length; i++)
		this.unit[i] = parseInt(st[counter++]);
	for(var i = 0; i < this.unit_adjust.length; i++)
		this.unit_adjust[i] = parseInt(st[counter++]);
	for(var i = 0; i < this.mag.length; i++)
		this.mag[i] = parseInt(st[counter++]);
	
	if(st.length == COOKIE_PARAMS_EQUIP) {
		this.weapon_motion = parseInt(st[counter++]);
		this.weapon = parseInt(st[counter++]);
		this.weapon_enh = parseInt(st[counter++]);
		this.weapon_hit = parseInt(st[counter++]);
		this.armor = parseInt(st[counter++]);
		this.armor_def = parseInt(st[counter++]);
		this.armor_evd = parseInt(st[counter++]);
		this.shield = parseInt(st[counter++]);
		this.shield_def = parseInt(st[counter++]);
		this.shield_evd = parseInt(st[counter++]);
	} else {
		this.weapon_motion = 0;
		this.weapon = 0;
		this.weapon_enh = 0;
		this.weapon_hit = 0;
		this.armor = 0;
		this.armor_def = 0;
		this.armor_evd = 0;
		this.shield = 0;
		this.shield_def = 0;
		this.shield_evd = 0;
	}
	return true;
}
Character.prototype.loadCookie = Character_loadCookie;

function Character_getDescriptions() {
	var s = ""
	s += CLASS_NAME[this.klass];
	var labels = ["go@", "so@", "U", "h", "_", "", "", "@^@"];
	s += " Lv" + this.level.toString() + "\n";
	for(var i = 0; i < 8; i++)
		s += labels[i] + "@" + this.outerStatus[i].toString() + " (" + this.innerStatus[i].toString() + ")\n"
	return s;
}
Character.prototype.getDescriptions = Character_getDescriptions;

function Array_merge(other) {
	var newarray = new Array(this.length);
	for(var i = 0; i < this.length; i++) {
		newarray[i] = this[i] ? parseInt(this[i]) : 0;
		newarray[i] += parseInt(other[i]);
	}
	return newarray;
}
Array.prototype.merge = Array_merge;
