﻿var MONOMATE = 0;
var DIMATE = 1;
var TRIMATE = 2;
var MONOFLUID = 3;
var DIFLUID = 4;
var TRIFLUID = 5;
var ANTIDOTE = 6;
var ANTIPARALYZE = 7;
var SOLATOMIZER = 8;
var MOONATOMIZER = 9;
var STARATOMIZER = 10;
var FOOD_NAME = [["モノメイト", "Monomate", "Monomate"],
                 ["ディメイト", "Dimate", "Dimate"],
                 ["トリメイト", "Trimate", "Trimate"],
                 ["モノフルイド", "Monofluid", "Monofluid"],
                 ["ディフルイド", "Difluid", "Difluid"],
                 ["トリフルイド", "Trifluid", "Trifluid"],
                 ["アンティドート", "Antidote", "Antidote"],
                 ["アンティパラライズ", "Antiparalyze", "Antiparalyze"],
                 ["ソルアトマイザー", "Sol Atomizer", "Sol Atomizer"],
                 ["ムーンアトマイザー", "Moon Atomizer", "Moon Atomizer"],
                 ["スターアトマイザー", "Star Atomizer", "Star Atomizer"]];
var FOOD_PRICE = [50, 300, 2000, 100, 500, 3600, 60, 60, 300, 350, 5000];
var MAG_DEF = 0;
var MAG_POW = 1;
var MAG_DEX = 2;
var MAG_MIND = 3;

var LEVEL_MAX = 200;
var SYNCHRO_MAX = 120;
var IQ_MAX = 200;

function langToNum(lang) {
	switch(lang) {
		case "en": return 1;
		case "ct": return 2;
		case "ja":
		default  : return 0;
	}
}

function Mag() {
	this.mag = MAG;
	this.lv = [5, 0, 0, 0];
	this.exp = [0, 0, 0, 0];
	this.synchro = 15;
	this.iq = 0;
	
	this.stage = 1;
	this.pb = [];
	
	this.owner_classtype = HUNTER;
	this.owner_sectionid = VIRIDIA;
	this.owner_sex = MALE;
	
	this.evelved = false;
}

Mag.prototype.getName = function(lang /*= "ja"*/) {return MAG_DATA[this.mag][6 + langToNum(lang)];}
Mag.prototype.getDef = function() {return this.lv[MAG_DEF];}
Mag.prototype.getPow = function() {return this.lv[MAG_POW];}
Mag.prototype.getDex = function() {return this.lv[MAG_DEX];}
Mag.prototype.getMind = function() {return this.lv[MAG_MIND];}
function Mag_level() {
	return this.getDef() + this.getPow() + this.getDex() + this.getMind();
}
Mag.prototype.level = Mag_level;
Mag.prototype.getTotalLevel = Mag_level;

function Mag_getPB(lang /*= "ja"*/) {
	var pb = new Array();
	for(var i = 0; i < this.pb.length; i++)
		pb.push(PB_NAME[this.pb[i]][langToNum(lang)]);
	return pb;
}
Mag.prototype.getPB = Mag_getPB;

function Mag_feed(food, klass, sectionid, rounddown_to_even) {
	this.owner_classtype = getClassType(klass);
	this.owner_sectionid = sectionid;
	this.owner_sex = getSex(klass);
	var growth = GROWTH_PATTERN[MAG_DATA[this.mag][4]][food];
	for(var i = 0; i < 4; i++) {
		this.exp[i] += growth[i];
		if(this.exp[i] < 0) this.exp[i] -= growth[i]; //結果が0を下回る場合は元に戻す
		if(this.exp[i] >= 100 && this.level() < LEVEL_MAX) {
			this.exp[i] -= 100;
			this.lv[i]++;
		}
		if(this.exp[i] >= 100 && this.level() == LEVEL_MAX) this.exp[i] = 99;
		//if(rounddown_to_even) this.exp[i] = this.exp[i] >> 1 << 1;
	}
	this.synchro += growth[4];
	if(this.synchro < 0) this.synchro = 0;
	if(this.synchro > SYNCHRO_MAX) this.synchro = SYNCHRO_MAX;
	this.iq += growth[5];
	if(this.iq < 0) this.iq = 0;
	if(this.iq > IQ_MAX) this.iq = IQ_MAX;
	
	this.evolve();
}
Mag.prototype.feed = Mag_feed;

Mag.prototype.rounddownToEven = function() {
	for(var i = 0; i < 4; i++)
		this.exp[i] = this.exp[i] >> 1 << 1;
}

function Mag_evolve() {
	var old_mag = this.mag;
	this.evolved = false;
	
	if(this.level() < 10 || this.stage == 0) return;

	if(this.level() >= 10 && this.level() < 35 && this.stage == 1) {
		switch(this.owner_classtype) {
			case HUNTER: this.mag = VARUNA; break;
			case RANGER: this.mag = KALKI; break;
			case FORCE: this.mag = VRITRA; break;
		}
		this.stage = 2;
	}
	if(this.level() >= 35 && this.level() < 50 && this.stage == 2) {
		var class_type;
		switch(this.mag) { //第3段階はキャラクターの職業によらず、第2段階マグの形態が影響する
			case VARUNA: class_type = HUNTER; break;
			case KALKI: class_type = RANGER; break;
			case VRITRA: class_type = FORCE; break;
		}
		var evol = getEvolutionType(this.getPow(), this.getDex(), this.getMind(), class_type)
		this.mag = MAG_EVOL_3RD[this.mag][evol];
		this.stage = 3;
	}
	if(this.level() >= 100 && (this.level() % 10) == 0) {
		//レアマグ判定--第4段階の判定に優先する
		var id_mod3 = this.owner_sectionid % 3;
		if((id_mod3 == 0 && this.getDef() + this.getDex() == this.getPow() + this.getMind()) ||
		   (id_mod3 == 1 && this.getDef() + this.getMind() == this.getPow() + this.getDex()) ||
		   (id_mod3 == 2 && this.getDef() + this.getPow() == this.getDex() + this.getMind())) {
			this.mag = MAG_EVOL_RARE[id_mod3][this.owner_classtype][this.owner_sex];
			this.stage = 0; //これ以上進化しない
		}
	}
	if(this.level() >= 50 && (this.level() % 5) == 0 && this.stage != 0) {
		//第4段階
		var id_mod = this.owner_sectionid % 2;
		var evol = getEvolutionType(this.getPow(), this.getDex(), this.getMind(), this.owner_classtype);
		if(this.owner_classtype == FORCE && this.getDef() >= 45)
			this.mag = (this.getPow() > this.getDex() && this.getPow() > this.getMind()) ? ANDHAKA : BANA;
		else
			this.mag = MAG_EVOL_4TH[this.owner_classtype][evol][id_mod];
		this.stage = 4;
	}
	this.evolved = (this.mag != old_mag);
	
	if(this.mag != old_mag && this.pb.length < 3) {
		var newpb = MAG_DATA[this.mag][5];
		if(newpb == PB_NONE) return;
		var is_found = false;
		for(var i = 0; i < this.pb.length; i++) is_found |= (newpb == this.pb[i]);
		if(!is_found) this.pb.push(newpb);
	}
}
Mag.prototype.evolve = Mag_evolve;

function getEvolutionType(pow, dex, mind, class_type) {
	var pow_gt_dex, dex_gt_mind, mind_gt_pow; //gt = greater than
	pow_gt_dex = pow >= dex;
	dex_gt_mind = dex >= mind;
	mind_gt_pow = mind >= pow;
	//1位と2位が同点だった場合の特例--優先ステータスが1位になる
	var arr = [pow, dex, mind].sort(function(a, b) { return (parseInt(a) >= parseInt(b)) ? -1 : 1}); //降順ソート
	if(arr[0] == arr[1])
		switch(class_type) {
			case HUNTER:
				pow_gt_dex = true;
				mind_gt_pow = false;
				break;
			case RANGER:
				pow_gt_dex = false;
				dex_gt_mind = true;
				break;
			case FORCE:
				dex_gt_mind = false;
				mind_gt_pow = true;
				break;
		}
	if(pow_gt_dex && dex_gt_mind) return 0;    //pow>dex>mind
	if(!mind_gt_pow && !dex_gt_mind) return 1; //pow>mind>dex
	if(!pow_gt_dex && !mind_gt_pow) return 2;  //dex>pow>mind
	if(dex_gt_mind && mind_gt_pow) return 3;   //dex>mind>pow
	if(mind_gt_pow && pow_gt_dex) return 4;    //mind>pow>dex
	if(!dex_gt_mind && !pow_gt_dex) return 5;  //mind>dex>pow
}

function Mag_toCookie() {
	var st = [this.mag, this.lv.join("_"), this.exp.join("_"), this.synchro, this.iq,
	          this.stage, this.pb.join("_")];
	return encodeURIComponent(st.join("_"));
}
Mag.prototype.toCookie = Mag_toCookie;

function Mag_loadCookie(cookie) {
	var st = decodeURIComponent(cookie).split("_");
	this.mag = parseInt(st[0]);
	this.lv = st.slice(1, 5);
	this.exp = st.slice(5, 9);
	for(var i = 0; i < 4; i++) {
		this.lv[i] = parseInt(this.lv[i]);
		this.exp[i] = parseInt(this.exp[i]);
	}
	this.synchro = parseInt(st[9]);
	this.iq = parseInt(st[10]);
	this.stage = parseInt(st[11]);
	if(st[12] == "") {
		this.pb = [];
	} else {
		this.pb = st.slice(12, st.length);
		for(var i = 0; i < this.pb.length; i++)
			this.pb[i] = parseInt(this.pb[i])
	}
}
Mag.prototype.loadCookie = Mag_loadCookie;


function getMagInfoHTML(magname, lang /*= "ja"*/) {
	var magdata = MAG_DATA[magname];
	var la = langToNum(lang);
	var h = "";
	h += "<table>";
	h += "<tr><th colspan=\"2\">" + magdata[la + FEATURE_MAGNAME] + "</th></tr>";
	h += "<tr><th>" + FEATURE_NAME[FEATURE_PBMAX][la] + "</th>";
	h += "<td class=\"maginfo\">" + ACTION_NAME[magdata[FEATURE_PBMAX]][la] + "</td></tr>";
	h += "<tr><th>" + FEATURE_NAME[FEATURE_DYING][la] + "</th>";
	h += "<td class=\"maginfo\">" + ACTION_NAME[magdata[FEATURE_DYING]][la] + "</td></tr>";
	h += "<tr><th>" + FEATURE_NAME[FEATURE_BOSS][la] + "</th>";
	h += "<td class=\"maginfo\">" + ACTION_NAME[magdata[FEATURE_BOSS]][la] + "</td></tr>";
	h += "<tr><th>" + FEATURE_NAME[FEATURE_DEAD][la] + "</th>";
	h += "<td class=\"maginfo\">" + ACTION_NAME[magdata[FEATURE_DEAD]][la] + "</td></tr>";
	h += "<tr><th>" + FEATURE_NAME[FEATURE_PB][la] + "</th>";
	h += "<td class=\"maginfo\">" + PB_NAME[magdata[FEATURE_PB]][la] + "</td></tr>";
	
	h += "</table>";
	
	return h;
}

function getMagDescription(mag, klass, sectionid, lang /*= "ja"*/) {
	if(mag.stage == 0) return "";
	
	var la = langToNum(lang);
	var h = "";
	if(mag.stage == 1) {
		h += "<p>" + ["<strong>第2段階</strong> Lv10以上", "2nd Stage: Lv10 or over"][la] + "</p>";
		switch(getClassType(klass)) {
			case HUNTER: h += getMagInfoHTML(VARUNA, lang); break;
			case RANGER: h += getMagInfoHTML(KALKI, lang); break;
			case FORCE: h += getMagInfoHTML(VRITRA, lang); break;
		}
		return h;
	}
	
	if(mag.stage == 2) {
		var mags = new Array(3);
		switch(mag.mag) {
			case VARUNA: mags = [RUDRA, MARUTAH, VAYU]; break;
			case KALKI: mags = [SURYA, MITRA, TAPAS]; break;
			case VRITRA: mags = [SUMBA, ASHVINAU, NAMUCI]; break;
		}
		h += "<p>" + ["<strong>第3段階</strong> Lv35以上", "3rd Stage: Lv35 or over"][la] + "</p>";
		var st = ["POW", "DEX", "MIND"];
		for(var i = 0; i < st.length; i++) {
			h += "<p>" + ["最大", "Max"][la] + " = " + st[i] + "</p>";
			h += getMagInfoHTML(mags[i], lang);
		}
		return h;
	}
	
	if(mag.stage >= 3) {
		var is_evenid = (sectionid % 2 == 0);
		var mags;
		var pattern;
		var classtype = getClassType(klass);
		switch(classtype) {
			case HUNTER:
				pattern = ["POW≧DEX≧MIND<br />DEX＝MIND＞POW",
				           "POW≧MIND＞DEX",
				           "DEX＞POW＞MIND",
				           "DEX＞MIND≧POW",
				           "MIND＞POW≧DEX",
				           "MIND＞DEX＞POW"];
				if(is_evenid) {
					mags = [VARAHA, BHIRAVA, ILA, NANDIN, KABANDA, USHASU];
				} else {
					mags = [KAMA, APSARAS, GARUDA, YAKSA, BANA, SOMA];
				} break;
			case RANGER:
				pattern = ["POW＞DEX≧MIND",
				           "POW＞MIND＞DEX<br />DEX≧POW＞MIND",
				           "DEX≧MIND≧POW<br />POW＝MIND＞DEX",
				           "MIND≧POW≧DEX",
				           "MIND＞DEX＞POW"];
				if(is_evenid) {
					mags = [KAMA, BHIRAVA, KAMA, VARAHA, APSARAS];
				} else {
					mags = [MADU, KAITABHA, VARAHA, KABANDA, DULGER];
				} break;
			case FORCE:
				pattern = ["POW＞DEX≧MIND",
				           "POW＞MIND＞DEX",
				           "DEX＞POW＞MIND",
				           "DEX＞MIND≧POW",
				           "MIND≧POW≧DEX<br />POW＝DEX＞MIND",
				           "MIND≧DEX＞POW",
				           "DEF45" + ["以上", " Over"][la] + "<br />POW＞MINDandDEX",
				           "DEF45" + ["以上", " Over"][la] + "<br />MINDorDEX≧POW"];
				if(is_evenid) {
					mags = [NARAKA, RAVANA, RIBHAVA, SITA, NAGA, KABANDA, ANDHAKA, BANA];
				} else {
					mags = [MARICA, NAGA, GARUDA, BHIRAVA, KUMARA, ILA, ANDHAKA, BANA];
				} break;
		}
		var sex = getSex(klass);
		switch(sectionid % 3) {
			case 0:
				pattern.push(["<strong>レアマグ</strong><br />Lv100以上10の倍数Lv", "Rare Mag: Lv100 or over<br />& Multiples of 10"][la] + "</p><p>DEF＋DEX＝POW＋MIND");
				if(classtype == HUNTER) mags.push((sex == MALE)? DEVA : SAVITRI);
				if(classtype == RANGER) mags.push((sex == MALE)? PUSHAN : RUKMIN);
				if(classtype == FORCE) mags.push((sex == MALE)? NIDRA : SATO);
				break;
			case 1:
				pattern.push(["<strong>レアマグ</strong><br />Lv100以上10の倍数Lv", "Rare Mag: Lv100 or over<br />& Multiples of 10"][la] + "</p><p>DEF＋MIND＝POW＋DEX");
				if(classtype == HUNTER) mags.push((sex == MALE)? RATI : SAVITRI);
				if(classtype == RANGER) mags.push((sex == MALE)? PUSHAN : RUKMIN);
				if(classtype == FORCE) mags.push((sex == MALE)? NIDRA : BHIMA);
				break;
			case 2:
				pattern.push(["<strong>レアマグ</strong><br />Lv100以上10の倍数Lv", "Rare Mag: Lv100 or over<br />& Multiples of 10"][la] + "</p><p>DEF＋POW＝DEX＋MIND");
				if(classtype == HUNTER) mags.push((sex == MALE)? RATI : SAVITRI);
				if(classtype == RANGER) mags.push((sex == MALE)? PUSHAN : DIWARI);
				if(classtype == FORCE) mags.push((sex == MALE)? NIDRA : BHIMA);
				break;
		}
		h +="<p>" + ["<strong>第4段階</strong><br />Lv50以上5の倍数Lv", "4th Stage: Lv50 or over<br />& Multiples of 5"][la] + "</p>";
		for(var i = 0; i < pattern.length; i++) {
			h += "<p>" + pattern[i] + "</p>";
			h += getMagInfoHTML(mags[i], lang);
		}
		return h;
	}
}
