var SECTIONID_ADJUST_HALFWIDTH = 45;
var SECTIONID_ADJUST_FULLWIDTH = 83;

function getSecID(charname, klass) {
	var cd = 0;
	var last_adjuster = 0;
	for(var i = 0; i < charname.length; i++) {
		var tmp_cd = charname.charCodeAt(i);
		cd += tmp_cd
		var adjuster = getAdjuster(tmp_cd)
		if(adjuster != last_adjuster) cd += adjuster;
		last_adjuster = adjuster;
	}
	return (cd + klass) % 10;
}
function getAdjuster(charCode) {
	if(charCode <= 0x00FF || (charCode >= 0xFF61 && charCode <= 0xFF91))
		return SECTIONID_ADJUST_HALFWIDTH;
	else
		return SECTIONID_ADJUST_FULLWIDTH;
}

/* o[W
function getSecID(charname, klass) {
	var cd = parseInt(charname.charCodeAt(charname.length - 1));
	return ((cd + klass) % 10);
}
*/
var ASCII = [0x0020, 0x007E];
var GREEK = [0x0391, 0x03C9];
var RUSSIAN = [0x0410, 0x0451];
var KANA = [0x3041, 0x30FE];
var ZEN_HAN = [0xFF01, 0xFF9F];
var ROMAN = [0x2160, 0x2182];
var SYMBOL1 = [0x2600, 0x266F];
var CJK_UNITS = [0x3280, 0x33FE];
var CJK_UNIFIED = [0x4E00, 0x9FA5];
var CJK_UNIFIED2 = [0xF900, 0xFA2D];

var U_C0_CONTROLS_AND_BASIC_LATIN = [0x0000, 0x007F];	//{e
var U_BASIC_LATIN_WITHOUT_CONTROLS = [0x0020, 0x007E];	//{e
var U_C1_CONTROLS_AND_LATIN_1_SUPPLEMENT = [0x0080, 0x00FF];	//eP⏕
var U_LATIN_EXTENDED_A = [0x0100, 0x017F];	//eg`
var U_LATIN_EXTENDED_B = [0x0180, 0x024F];	//ega
var U_IPA_EXTENSIONS = [0x0250, 0x02AF];	//ho`g
var U_SPACING_MODIFIER_LETTERS = [0x02B0, 0x02FF];	//Oi𔺂C
var U_COMBINING_DIACRITICAL_MARKS = [0x0300, 0x036F];	//_CANeBJ}[N(\)
var U_GREEK_AND_COPTIC = [0x0370, 0x03FF];	//MVAyуRvg
var U_CYRILLIC = [0x0400, 0x04FF];	//L[
var U_CYRILLIC_SUPPLEMENTARY = [0x0500, 0x052F];	//@V
var U_ARMENIAN = [0x0530, 0x058F];	//AjA
var U_HEBREW = [0x0590, 0x05FF];	//wuC
var U_ARABIC = [0x0600, 0x06FF];	//ArA
var U_SYRIAC = [0x0700, 0x074F];	//VA
var U_THAANA = [0x0780, 0x07BF];	//^[i
var U_DEVANAGARI = [0x0900, 0x097F];	//f[@i[K[
var U_BENGALI = [0x0980, 0x09FF];	//xK
var U_GURMUKHI = [0x0A00, 0x0A7F];	//OL[
var U_GUJARATI = [0x0A80, 0x0AFF];	//OW[eB
var U_ORIYA = [0x0B00, 0x0B7F];	//I[
var U_TAMIL = [0x0B80, 0x0BFF];	//^~
var U_TELUGU = [0x0C00, 0x0C7F];	//eO
var U_KANNADA = [0x0C80, 0x0CFF];	//Ji_
var U_MALAYALAM = [0x0D00, 0x0D7F];	//}[
var U_SINHALA = [0x0D80, 0x0DFF];	//Vn
var U_THAI = [0x0E00, 0x0E7F];	//^C
var U_LAO = [0x0E80, 0x0EFF];	//I
var U_TIBETAN = [0x0F00, 0x0FFF];	//`xbg
var U_MYANMAR = [0x1000, 0x109F];	//~}[
var U_GEORGIAN = [0x10A0, 0x10FF];	//OWA
var U_HANGUL_JAMO = [0x1100, 0x11FF];	//nO
var U_ETHIOPIC = [0x1200, 0x137F];	//G`IsA
var U_CHEROKEE = [0x13A0, 0x13FF];	//`FL[
var U_UNIFIED_CANADIAN_ABORIGINAL_SYLLABICS = [0x1400, 0x167F];	//Ji_Z
var U_OGHAM = [0x1680, 0x169F];	//I[
var U_RUNIC = [0x16A0, 0x16FF];	//[
var U_TAGALOG = [0x1700, 0x171F];	//@
var U_HANUNOO = [0x1720, 0x173F];	//@
var U_BUHID = [0x1740, 0x175F];	//@
var U_TAGBANWA = [0x1760, 0x177F];	//@
var U_KHMER = [0x1780, 0x17FF];	//N[
var U_MONGOLIAN = [0x1800, 0x18AF];	//S
var U_LATIN_EXTENDED_ADDITIONAL = [0x1E00, 0x1EFF];	//egǉ
var U_GREEK_EXTENDED = [0x1F00, 0x1FFF];	//MVAg
var U_GENERAL_PUNCTUATION = [0x2000, 0x206F];	//ʋǓ_
var U_SUPERSCRIPTS_AND_SUBSCRIPTS = [0x2070, 0x209F];	//tEt
var U_CURRENCY_SYMBOLS = [0x20A0, 0x20CF];	//ʉ݋L
var U_COMBINING_DIACRITICAL_MARKS_FOR_SYMBOLS = [0x20D0, 0x20FF];	//Lp_CANeBJ}[N(\)
var U_LETTERLIKE_SYMBOLS = [0x2100, 0x214F];	//lL
var U_NUMBER_FORMS = [0x2150, 0x218F];	//ɏ
var U_ARROWS = [0x2190, 0x21FF];	//
var U_MATHEMATICAL_OPERATORS = [0x2200, 0x22FF];	//wL
var U_MISCELLANEOUS_TECHNICAL = [0x2300, 0x23FF];	//̑̋ZppL
var U_CONTROL_PICTURES = [0x2400, 0x243F];	//@\pL
var U_OPTICAL_CHARACTER_RECOGNITION = [0x2440, 0x245F];	//wIEFCOCR
var U_ENCLOSED_ALPHANUMERICS = [0x2460, 0x24FF];	//͂݉p
var U_BOX_DRAWING = [0x2500, 0x257F];	//rf
var U_BLOCK_ELEMENTS = [0x2580, 0x259F];	//ubNvf
var U_GEOMETRIC_SHAPES = [0x25A0, 0x25FF];	//􉽊w͗l
var U_MISCELLANEOUS_SYMBOLS = [0x2600, 0x26FF];	//̑̋L
var U_DINGBATS = [0x2700, 0x27BF];	//L
var U_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_A = [0x27C0, 0x27EF];	//@
var U_SUPPLEMENTAL_ARROWS_A = [0x27F0, 0x27FF];	//@
var U_BRAILLE_PATTERNS = [0x2800, 0x28FF];	//_}`
var U_SUPPLEMENTAL_ARROWS_B = [0x2900, 0x29FF];	//@
var U_MISCELLANEOUS_MATHEMATICAL_SYMBOLS_B = [0x2980, 0x29FF];	//@
var U_SUPPLEMENTAL_MATHEMATICAL_OPERATORS = [0x2A00, 0x2AFF];	//@
var U_CJK_RADICALS_SUPPLEMENT = [0x2E80, 0x2EFF];	//bij⏕
var U_KANGXI_RADICALS = [0x2F00, 0x2FDF];	//N
var U_IDEOGRAPHIC_DESCRIPTION_CHARACTERS = [0x2FF0, 0x2FFF];	//\LqCIDC
var U_CJK_SYMBOLS_AND_PUNCTUATION = [0x3000, 0x303F];	//bij̋LyыǓ_
var U_HIRAGANA = [0x3040, 0x309F];	//
var U_KATAKANA = [0x30A0, 0x30FF];	//Љ
var U_BOPOMOFO = [0x3100, 0x312F];	//
var U_HANGUL_COMPATIBILITY_JAMO = [0x3130, 0x318F];	//nO݊
var U_KANBUN = [0x3190, 0x319F];	//pL(̑̂bij)
var U_BOPOMOFO_EXTENDED = [0x31A0, 0x31BF];	//g
var U_ENCLOSED_CJK_LETTERS_AND_MONTHS = [0x3200, 0x32FF];	//݂͂bijE
var U_CJK_COMPATIBILITY = [0x3300, 0x33FF];	//bij݊p
var U_CJK_UNIFIED_IDEOGRAPHS_EXTENSION_A = [0x3400, 0x3DBF];	//bijg`
var U_CJK_UNIFIED_IDEOGRAPHS = [0x4E00, 0x9FAF];	//bij
var U_YI_SYLLABLES = [0xA000, 0xA48F];	//C
var U_YI_RADICALS = [0xA490, 0xA4CF];	//C
var U_HANGUL_SYLLABLES = [0xAC00, 0xD7AF];	//nOߕ
var U_HIGH_SURROGATE_AREA = [0xD800, 0xDBFF];	//@
var U_LOW_SURROGATE_AREA = [0xDC00, 0xDFFF];	//@
var U_PRIVATE_USE_AREA = [0xE000, 0xF8FF];	//p̈
var U_CJK_COMPATIBILITY_IDEOGRAPHS = [0xF900, 0xFAFF];	//bij݊
var U_ALPHABETIC_PRESENTATION_FORMS = [0xFB00, 0xFB4F];	//At@xbg\``
var U_ARABIC_PRESENTATION_FORMS_A = [0xFB50, 0xFDFF];	//ArA\``
var U_VARIATION_SELECTORS = [0xFE00, 0xFE0F];	//@
var U_COMBINING_HALF_MARKS = [0xFE20, 0xFE2F];	//L(\)
var U_CJK_COMPATIBILITY_FORMS = [0xFE30, 0xFE4F];	//bij݊`
var U_SMALL_FORM_VARIANTS = [0xFE50, 0xFE6F];	//`
var U_ARABIC_PRESENTATION_FORMS_B = [0xFE70, 0xFEFF];	//ArA\`a
var U_HALFWIDTH_AND_FULLWIDTH_FORMS = [0xFF00, 0xFFEF];	//pESp`
var U_SPECIALS = [0xFFF0, 0xFFFF];	//pr

var SET_LATIN = [U_BASIC_LATIN_WITHOUT_CONTROLS, [0xFF01, 0xFF5D]]; //At@xbg
var SET_HIRAGANA_KATAKANA = [U_HIRAGANA, U_KATAKANA, [0xFF5E, 0xFF9F]]; //Ђ炪ȁEJ^Ji
var SET_CJK_UNIFIED = [U_CJK_UNIFIED_IDEOGRAPHS, U_CJK_COMPATIBILITY_IDEOGRAPHS]; //
var SET_GREEK_CYRILLIC = [U_GREEK_AND_COPTIC, U_CYRILLIC, U_CYRILLIC_SUPPLEMENTARY]; //MVEL
var SET_SYMBOLS = [U_NUMBER_FORMS, U_MATHEMATICAL_OPERATORS, U_ENCLOSED_ALPHANUMERICS,
	U_BOX_DRAWING, U_MISCELLANEOUS_SYMBOLS, U_CJK_COMPATIBILITY]; //L

function getExpectedChars(klass, id, charGroups, charname) {
	var mod = (id - getSecID(charname, klass));
	if(mod < 0) mod += 10;
	var last_adjuster = getAdjuster(charname.charCodeAt(charname.length - 1));
	
	if(charGroups == undefined)
		charGroups = SET_LATIN.concat(SET_HIRAGANA_KATAKANA).concat(SET_GREEK_CYRILLIC).concat(SET_SYMBOLS).concat(SET_CJK_UNIFIED);
	var result = "";
	for(var j = 0; j < charGroups.length; j++) {
		var adjuster = 0;
		for(var i = charGroups[j][0]; i <= charGroups[j][1]; i++) {
			adjuster = getAdjuster(i);
			if((i + ((adjuster == last_adjuster)? 0 : adjuster)) % 10 == mod) result += String.fromCharCode(i);
		}
	}
	return result;
}

/* o[W
function getExpectedChars(klass, id, charGroups) {
	var mod = (id - klass) % 10;
	if(mod < 0) mod += 10;
	
	if(charGroups == undefined)
		charGroups = SET_LATIN.concat(SET_HIRAGANA_KATAKANA).concat(SET_GREEK_CYRILLIC).concat(SET_SYMBOLS).concat(SET_CJK_UNIFIED);
		//charGroups = [ASCII, KANA, GREEK, RUSSIAN, ZEN_HAN, ROMAN, SYMBOL1, CJK_UNITS, CJK_UNIFIED, CJK_UNIFIED2];
	var result = "";
	for(var j = 0; j < charGroups.length; j++) {
		for(var i = charGroups[j][0] + ((mod + 10 - (charGroups[j][0] % 10)) % 10); i <= charGroups[j][1]; i += 10) {
			//if(i % 10 == mod) result += String.fromCharCode(i);
			result += String.fromCharCode(i);
		}
	}
	return result;
}
*/
